// programme minimum de test
// les Serial ont été rajoutés pour debug/test (sans LCD !!!)
//**********************************************************
// BIBLIOTHEQUES
// incluses dans le package Arduino de base
#include <LiquidCrystal.h>  // LCD

// ajoutées
// pour chainage des chaines de caractères avec &&
#include <Streaming_ger.h>
// indispensable pour ger_bargraph (formatt)
#include <ger_format.h>

//**********************************************************
// DECLARATIONS GENERALES
// LCD initialize the library with the numbers of the interface pins
LiquidCrystal lcd(4, 2, 6, 7, 8, 9);

int entree=-100, ix=10, mem=-9999;
float sortie;

int ixx;
char buf[21];

int debug=0;

// sous-programmes spécifiques pour le bargraphe
// voir dans le s/p bargraph
//#define creercaracterestype  1 //
#define creercaracteresdemo  1 // si on veut un test au démarrage
#include <ger_lcd_bargraph.h>

//**********************************************************
// INITIALISATIONS
void setup() {

// clavier analogique à 6 touches avec diodes 1N4148
  pinMode(A0,INPUT);
  digitalWrite(A0,HIGH);
   
// init lcd
  lcd.begin(16, 2);  // initialise le LCD 16 colonnes x 2 lignes

// programmation des caractères LCD
  ger_creercaracteres();

}

//**********************************************************
// PROGRAMME PRINCIPAL
void loop() {
  
// lecture clavier
    ixx=(analogRead(A0)+50)/100;
    if (ixx==1) entree-=1;
    if (ixx==2) entree+=1;
    if (ixx==3) entree-=10;
    if (ixx==4) entree=250;
    if (ixx==5) entree+=10;

    delay(160);

    if (entree != mem) {
      mem=entree;
  
// affichage
// bargraphe de 10 cases avec valeur après en 3 chiffres significatifs
      lcd.setCursor(0, 0); lcd && ger_bargraph (entree, 0, 500, 0., 500.,  0., 500., 10, -3, 'x', sortie);

// indicateur de batterie en 1 seule case à droite, le bargraphe ne couvre que de 10 à 15V 
      lcd.setCursor(15, 0); lcd && ger_bargraph (entree, 0, 500, 0., 25.,  10., 15., 1, 0, ' ', sortie);

// bargraphe de 16 cases avec valeur surimprimée et symbole degrés centigrades
      lcd.setCursor(0, 1); lcd && ger_bargraph (entree, 0, 500, 0., 25., 10., 15., 16, 3, char(7), sortie);

    }

}

